#include "aux/aux_interface.h"

namespace daq
{
    namespace ftk
    {

        aux_interface::aux_interface(uint _slot, uint _fpga, std::string _name) :
            m_slot(_slot), m_fpga(_fpga), m_name(_name), m_vme(VMEManager::global().aux(_slot, _fpga)),
            m_event_rate(100), m_firmware(0x0), m_requireMatch(false)
        { }

        aux_interface::~aux_interface() noexcept {
            // ***DO NOT DELETE VMEInterface* OBJECTS***
            // These are global objects generated by
            // VMEManager and get deleted when the 
            // program ends, when the VMEManager destructor is called
            // This would cause seg faults
            //delete m_vme;
        }

        uint aux_interface::get_fpga_idx()
        {
            return m_fpga;
        }


        // Run Control //
        void aux_interface::configure()
        {

        reset_regs();

        set_upstream_flow(false);
        enable_upstream_rx(false);
        set_downstream_flow(false);

        reset_all();
        ERS_LOG("Check FREEZE after reset_all()");
        check_freeze();

        enable_amb_freeze(false);
        reset_freeze();

        try{
            load_rams(m_isLoadMode);//calls load_rams in aux_interface which finds
        }
        catch(ers::Issue &ex){
            daq::ftk::ftkException e(ERS_HERE, name_ftk(), "Problem loading RAMs", ex);
            if(isFatalMode) throw e;
            else ers::error(e);
        }

        // Set common settings
        //read clock rate register
        uint clock = m_vme->read_word(CLOCK_FREQUENCY);
        uint throttle=0;
        if(m_event_rate != 0){
            if(clock != 0)
                throttle=clock*1000/m_event_rate;
            else
                throttle=120000/m_event_rate;
        }
        ERS_LOG("Setting Event Rate Maximum: " << std::dec << m_event_rate << " with counts between events: " << throttle );
        m_vme->write_word(TMODE, 0x1);
        m_vme->write_word(0xa0 , throttle);
        m_vme->write_word(TMODE, 0x0);
        }

        void aux_interface::check_fw_versions(){
            uint version = read_version();

            std::stringstream cppstringssuck;
            cppstringssuck <<std::hex<<version;
            std::string  versions  = cppstringssuck.str();

            std::stringstream cppstringssuck2;
            cppstringssuck2 <<std::hex<<m_firmware;
            std::string  firmwares  = cppstringssuck2.str();

            ERS_LOG("FIRMWARE VERSION " << std::hex << version << " on FPGA " << std::dec << m_fpga << " slot " << m_slot << " and expected " << std::hex << m_firmware);
            if(version != m_firmware) {

                daq::ftk::WrongFwVersion ex(ERS_HERE, name_ftk(), " ", m_fpga, (uint32_t)version, (uint32_t)m_firmware);

                if( versions[1] == '0'){
                    daq::ftk::ftkException e(ERS_HERE, name_ftk(), "AUX is unprogrammed. Please run reconfigureSelf.sh on sbc " + m_name.substr(8, 1), ex);
                    throw e;
                }
                else ers::warning(ex);

            }
        }

        void aux_interface::connect()//called in aux_card for each fpga
        {
            reset_sync();
        }

        void aux_interface::prepareForRun()
        {
            //reset_spybuffers();
            //reset_error_counters();
            //reset_freeze();

            set_downstream_flow(true);
            set_upstream_flow(true);
        }

        // Functionality //
        void aux_interface::reset_all() 
        {
            reset_tx_fifos();
            //reset_regs();
            reset_error_counters();
            reset_xcvr();
            reset_sync();
            reset_main();
            reset_logic();
            reset_spybuffers();
            reset_freeze();
            reset_error_latches();
        }

        void aux_interface::reset_logic() 
        {
            ERS_LOG("Reset Logic " << std::dec << m_fpga << " slot " << m_slot);
        }

        void aux_interface::reset_main()
        { 
            ERS_LOG("Reset Main    " << std::dec << m_fpga << " slot " << m_slot);
            m_vme->write_word(RESET,  0x1);
        }

        void aux_interface::reset_spybuffers()
        {
            ERS_LOG("Reset Spybuff " << std::dec << m_fpga << " slot " << m_slot);
            m_vme->write_word(RESETS, 0x1);
        }

        void aux_interface::reset_error_latches()
        {
            ERS_LOG("Reset Latches " << std::dec << m_fpga << " slot " << m_slot);
            m_vme->write_word(RESETS, 0x200);
        }

        void aux_interface::reset_freeze()
        {
            ERS_LOG("Reset Freezes " << std::dec << m_fpga << " slot " << m_slot);
            m_vme->write_word(RESETS, 0x100);
        }

        void aux_interface::reset_xcvr()
        {
            ERS_LOG("Reset XCVR    " << std::dec << m_fpga << " slot " << m_slot);
            m_vme->write_word(RESET_XCVR, 0x1);
        }

        void aux_interface::reset_error_counters()
        {
            ERS_LOG("Reset Error Counters " << std::dec << m_fpga << " slot " << m_slot);
            // should be pulsed, so don't need TMOD; 
            // just being consistent with aux_reset, for now.
            // m_vme->write_word(TMODE,  0x1);
            m_vme->write_word(RESETS, 0x2);
            // m_vme->write_word(TMODE,  0x0);
        }

        // bool aux_interface::check_link_status()
        // {
        //   ERS_LOG("Check Link Status");
        // }

        void aux_interface::reset_sync()
        { 
            ERS_LOG("Reset Sync" << std::dec << m_fpga << " slot " << m_slot);
            m_vme->write_word(TMODE,  0x1);
            m_vme->write_bit(RESET_SYNC, 1, true); 
            m_vme->write_bit(RESET_SYNC, 1, false); 
            m_vme->write_word(TMODE,  0x0);
        }

        void aux_interface::reset_tx_fifos()
        { 
            ERS_LOG("Reset Tx FIFOs" << std::dec << m_fpga << " slot " << m_slot);
            m_vme->write_word(TMODE,  0x1);
            m_vme->write_bit(TX_FIFOWRITE, 4, true); 
            m_vme->write_bit(TX_FIFOWRITE, 4, true); 
            m_vme->write_word(TMODE,  0x0);
        }

        void aux_interface::reset_regs() 
        {
            ERS_LOG("Reset Registers" << std::dec << m_fpga << " slot " << m_slot);
            m_vme->write_word(TMODE, 0x1);
            for (int regaddr=1; regaddr<=15; regaddr++)
                m_vme->write_word(regaddr << 4, 0);
            m_vme->write_word(TMODE, 0x0);
        }

        void aux_interface::check_freeze()
        {
            ERS_LOG("Checking Freeze on FPGA " << std::dec << m_fpga << " slot " << m_slot);
            u_int register_content;
            register_content=m_vme->read_word(FREEZE_STATUS);

            std::stringstream cppstringssuck;
            cppstringssuck <<std::hex<<std::left<<std::setw(13)<<register_content;
            std::string  register_contents  = cppstringssuck.str();

            ERS_LOG("FREEZE " << "0x" << std::hex << std::left << setw(13) << register_content <<" on FPGA " << std::dec << m_fpga << " slot " << m_slot);
            if (register_content != 0){
                daq::ftk::FTKMonitoringError ex(ERS_HERE, name_ftk(), "Saw FREEZE 0x" +register_contents+ " on FPGA " +std::to_string(m_fpga)+ " slot " +std::to_string(m_slot));
                ers::warning(ex);
                if(m_fpga > 2){
                    register_content=m_vme->read_word(DO_FREEZE);
                    ERS_LOG("DO FREEZE " << "0x" << std::hex << std::left << setw(13) << register_content <<" on FPGA " << std::dec << m_fpga << " slot " << m_slot);
                }
            }
        }

        uint aux_interface::read_version()
        {
            ERS_LOG("Read version" << std::dec << m_fpga << " slot " << m_slot << " got " <<  m_vme->read_word(INFO));
            //return m_vme->read_word(INFO)>>8;
            return m_vme->read_word(INFO);
        }

        void aux_interface::set_requireMatch(bool requireMatch)
        {
            if(requireMatch)
                ERS_LOG("Require FPGA firmware version to match OKS for FPGA "<<m_fpga);
            else
                ERS_LOG("Do not check FPGA firmare version for FPGA "<<m_fpga);
            m_requireMatch = requireMatch;
        }

        void aux_interface::set_firmware(uint firmware)
        {
            ERS_LOG("Setting expected firmware version for FPGA "<<m_fpga<<" to "<<std::hex<<firmware);
            m_firmware = firmware;
        }

        void aux_interface::set_checksumWarning(bool warningOnly)
        {
            if(warningOnly)
                ERS_LOG("Give warnings for failed checksums"<<m_fpga);
            else
                ERS_LOG("Throw errors for failed checksums"<<m_fpga);
        }

        void aux_interface::load_rams(bool isLoadMode)
        {
            ERS_LOG("Load RAMs " << std::dec << m_fpga << " slot " << m_slot);
        }

        void aux_interface::enable_upstream_rx(bool enable)
        {
            ERS_LOG("FPGA " << std::dec << m_fpga << " slot " << m_slot << " upstream rx: " << enable);
        }

        void aux_interface::set_upstream_flow(bool enable)
        {
            ERS_LOG("FPGA " << std::dec << m_fpga << " slot " << m_slot << " upstream hold: " << enable);
        }

        void aux_interface::set_downstream_flow(bool enable)
        {
            ERS_LOG("FPGA " << std::dec << m_fpga << " slot " << m_slot << " downstream flow: " << enable);
        }

        void aux_interface::set_event_rate(uint event_rate)
        {
            m_event_rate=event_rate;
        }

        void aux_interface::set_isLoadMode(bool loadmode)
        {
            m_isLoadMode =loadmode;
        }

        void aux_interface::enable_amb_freeze(bool enable)
        {
            ERS_LOG("Set enable AMB freeze to " << enable);
            m_vme->write_word(TMODE, 0x1);
            m_vme->write_bit (0x10 , 3, enable);
            m_vme->write_word(TMODE, 0x0);
        }

        void aux_interface::disable_block_writes(bool v) {
            m_vme->disableBlockTransfers(v);
        }

    }
}


